#include <mockturtle-rt.h>
#include <hw/mockturtle_config.h>

int main()
{
	int cpu, hmq;
	const struct trtl_config_rom *cfgrom = trtl_config_rom_get();

	pr_debug("PURGE MESSAGES\r\n");
	pr_debug("Fill the HMQ while CPU is not running\r\n");

	cpu = 0;
	for (hmq = 0; hmq < cfgrom->n_hmq[cpu]; ++hmq) {
		if ((hmq_poll_in() & (1 << hmq)) != (1 << hmq)) {
			pr_error("HMQ-%d after poll: 0x%lx\r\n",
				 hmq, hmq_poll_in());
			return -1;
		}

		mq_purge(TRTL_HMQ, hmq);

		if ((hmq_poll_in() & (1 << hmq)) == (1 << hmq)) {
			pr_error("HMQ-%d after poll: 0x%lx\r\n",
				 hmq, hmq_poll_in());
			return -1;
		}
	}

	if (hmq_poll_in() != 0) {
		pr_error("END poll: 0x%lx\r\n", hmq_poll_in());
		return -1;
	}

	pp_printf("OK\r\n");
	return 0;
}
